//+------------------------------------------------------------------+
//|                                                    Earn4Sure1.mq4 |
//|                                       Copyright  2008, ForEXpert|
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, ForEXpert"
#property link      "TheForEXpert@gmail.com"

#define STUPID 0x60BE57100

#include "libraries/common.mq4"
#include "libraries/trial.mq4"

extern string     Lots_             =  "If 0 it is counted automatically, otherwise fixed value, should be >= 0";
extern double     Lots              =  0;
extern string     RiskPercentage_   =  "Part of free margin in percent you can risk should be 0 -- 100";
extern int        RiskPercentage    =  0;
extern string     Slippage_         =  "MaximumSlippage";
extern int        Slippage          =  1;
extern string     Target_           =  "Maximum profit you can get";
extern int        Target            =  0;
extern string     Loss_             =  "Maximum loss you can get";
extern int        Loss              =  30;
extern string     Aggressive_       =  "Put true if you want more orders to be opened";
extern bool       Aggressive        =  true;
extern string     MaxOrders_        =  "Maximum orders allowed. If 3, it can be 3 sells and 3 buys active at a time";
extern int        MaxOrders         =  3;
extern string     MinimumDistance_  =  "Minimum distance between same type orders";
extern int        MinimumDistance   =  10;

double LotsToBid;

double Last;
int SignalLevel;

datetime LastTime;
bool OpensAllowed; 

datetime LastTrialTime;

void CheckForExpired()
{
   for(int i = 0; i < OrdersTotal(); i++)
   {
      // already closed
      if(OrderSelect(i, SELECT_BY_POS) == false) continue;
      // not current symbol
      if(OrderSymbol() != Symbol()) continue;
      // order was opened in another way
      if(OrderMagicNumber() != STUPID) continue;
      
      if (TimeCurrent() - OrderOpenTime() > 30*60)
      {
         if(OrderType() == OP_BUY && MathRound((OrderTakeProfit() - OrderOpenPrice())/Point) > 1)
         {
            OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), OrderOpenPrice() + Point, 0);
            RefreshRates();
         }
         
         if(OrderType() == OP_SELL && MathRound((OrderOpenPrice() - OrderTakeProfit())/Point) > 1)
         {
            OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), OrderOpenPrice() - Point, 0);
            RefreshRates();
         }
      }
   }
}

double GetLowestPrice(int MagicNumber)
{
   double min = 1000000;
      
   for(int i = 0; i < OrdersTotal(); i++)
   {
      // already closed
      if(OrderSelect(i, SELECT_BY_POS) == false) continue;
      // not current symbol
      if(OrderSymbol() != Symbol()) continue;
      // order was opened in another way
      if(OrderMagicNumber() != MagicNumber) continue;
      
      if(OrderType() == OP_BUY)
      {
         double current = OrderOpenPrice();
         if (current < min)
         {
            min = current;
         }
      }
   }
   return (min);
}

void OpenBuy()
{
   if (!OpensAllowed) return;
   if (GetLowestPrice(STUPID) - MinimumDistance*Point < Ask) return;
   
   double Profit = 0;
   double SL = 0;
   
   if (Lots == 0) LotsToBid = GetLotsToBid(RiskPercentage);
   
   if (Target > 0)   Profit = Target;
   else              Profit = GetStopLevel();
   
   if (Loss > 0)     SL = Loss;
   else              SL = 3*Profit;
   
   Profit = Ask + Profit*Point;
   SL = Ask - SL*Point;
   
   
   double memory = Ask;
   
   if (OrderSend(Symbol(), OP_BUY, LotsToBid, Ask, Slippage, SL, Profit, NULL, STUPID, 0, Blue) == -1)
   {
      if (NeedToRetry(GetLastError()))
      {
         RefreshRates();
         if (Ask >= memory)
         {
            Profit = Ask + Profit*Point;
            SL = Ask - SL*Point;
            OrderSend(Symbol(), OP_BUY, LotsToBid, Ask, Slippage, SL, Profit, NULL, STUPID, 0, Blue);
         }
      }
   }
   RefreshRates();
   
}

double GetHighestPrice(int MagicNumber)
{
      double max = 0;
      
   for(int i = 0; i < OrdersTotal(); i++)
   {
      // already closed
      if(OrderSelect(i, SELECT_BY_POS) == false) continue;
      // not current symbol
      if(OrderSymbol() != Symbol()) continue;
      // order was opened in another way
      if(OrderMagicNumber() != MagicNumber) continue;
      
      if(OrderType() == OP_SELL)
      {
         double current = OrderOpenPrice();
         if (current > max)
         {
            max = current;
         }
      }
   }
   return (max);
}

void OpenSell()
{
   if (!OpensAllowed) return;
   if (GetHighestPrice(STUPID) + MinimumDistance*Point > Ask) return;

   double Profit = 0;
   double SL = 0;
   
   if (Lots == 0) LotsToBid = GetLotsToBid(RiskPercentage);
   
   if (Target > 0)   Profit = Target;
   else              Profit = GetStopLevel();
   
   if (Loss > 0)     SL = Loss;
   else              SL = 3*Profit;
   
   Profit = Bid - Profit*Point;
   SL = Bid + SL*Point;
   
   double memory = Ask;
   
   if (OrderSend(Symbol(), OP_SELL, LotsToBid, Bid, Slippage, SL, Profit, NULL, STUPID, 0, Red) == -1)
   {
      if (NeedToRetry(GetLastError()))
      {
         RefreshRates();
         if (Ask <= memory)
         {
            Profit = Bid - Profit*Point;
            SL = Bid + SL*Point;
            OrderSend(Symbol(), OP_SELL, LotsToBid, Bid, Slippage, SL, Profit, NULL, STUPID, 0, Red);
         }
      }
   }
   RefreshRates();

}

void Check()
{
   if (MathAbs(Ask - Last) > SignalLevel*Point)
   {
      string symbol = Symbol();
      
      double min = iLow(symbol, PERIOD_M1, iLowest(symbol, PERIOD_M1, MODE_LOW, 10));
      double max = iHigh(symbol, PERIOD_M1, iHighest(symbol, PERIOD_M1, MODE_HIGH, 10));
      
      double longMin = iLow(symbol, PERIOD_M5, iLowest(symbol, PERIOD_M5, MODE_LOW, 20));
      double longMax = iHigh(symbol, PERIOD_M5, iHighest(symbol, PERIOD_M5, MODE_HIGH, 20));
      
      double memory = Ask;
      
      if (Ask > Last && max > Ask && max < longMax)
      {
         ClosePositiveBuys(STUPID, Slippage);
         
         if (Ask >= memory && (GetOrdersCount(STUPID, OP_SELL) < MaxOrders || MaxOrders == 0)) OpenSell();
      }
      
      if (Ask < Last && min < Ask && min > longMin)
      {
         ClosePositiveSells(STUPID, Slippage);
         
         if (Ask <= memory && (GetOrdersCount(STUPID, OP_BUY) < MaxOrders || MaxOrders == 0)) OpenBuy();
      }
   }
}

int init()
{
   LotsToBid = Lots;
   
   SignalLevel = 1;
   //if (!Aggressive) SignalLevel++;
   
   Last = 0;
   LastTrialTime = 0;
   OpensAllowed = true;
   if (!IsTesting()) CheckTrialTrades(STUPID, 1000, "Trial expired");
}

void reinit()
{
   Last = 0;
}

int start()
{
   //    .
   /*if (TimeMinute(TimeCurrent()) % 10 == 0)
   {
      OpensAllowed = true;
      if (!IsTesting()) CheckTrialTrades(STUPID, 1000, "TrialExpired");
      if (!GetActiveOrders(STUPID) && !OpensAllowed && TimeCurrent() - LastTrialTime > 24*60*60)
      {
         Alert("This version of expert has limited usability. To get fully functional version, please, mail to theforexpert@gmail.com");
         Alert("   .    ,   theforexpert@gmail.com");
         LastTrialTime = TimeCurrent();
      }
   }*/
   
   if (Last == 0)
   {
      Last = Ask;
      LastTime = TimeCurrent();
      return (0);
   }
   
   CheckForExpired();
   
   if (TimeCurrent() - LastTime > 120)
   {
      reinit();
      return(0);
   }
   
   Check();
   
   Last = Ask;
   LastTime = TimeCurrent();
   

   return(0);
}